from typing import List

class Attribute:
    def __init__(self) -> None: ...
    def push_line2D(self, arg0: List[float]) -> None: ...
    def push_line3D(self, arg0: List[float]) -> None: ...
    def push_point2D(self, arg0: List[float]) -> None: ...
    def push_point3D(self, arg0: List[float]) -> None: ...
    def push_polygon2D(self, arg0: List[List[float]]) -> None: ...
    def push_polygon3D(self, arg0: List[List[float]]) -> None: ...
    @property
    def geom_type(self) -> int: ...

class Edge:
    def __init__(self, arg0: int, arg1: int, arg2: int, arg3: Attribute, arg4: json) -> None: ...

class Graph:
    def __init__(self) -> None: ...
    def add_edge(self, arg0: Edge) -> None: ...
    def add_node(self, arg0: Node) -> None: ...
    @property
    def edge_count(self) -> int: ...
    @property
    def node_count(self) -> int: ...

class Grid:
    def __init__(self, arg0: float, arg1: float) -> None: ...
    def add_layer(self, arg0: Layer) -> None: ...
    def add_model(self, arg0: Model) -> None: ...
    def tile_merge(self) -> None: ...
    def to_gltf(self, arg0: str) -> None: ...

class Layer:
    def __init__(self) -> None: ...
    def add_model(self, arg0: Model) -> None: ...
    def add_models(self, arg0: List[Model]) -> None: ...
    def from_gltf(self, arg0: str) -> None: ...
    def get_models(self) -> List[Model]: ...
    def map_to_height(self, arg0: Layer) -> None: ...
    def move_to_plane_z(self, arg0: float) -> None: ...
    def simplify_envelope(self) -> None: ...
    def simplify_remesh_height(self, arg0: float, arg1: int) -> None: ...
    def to_gltf(self, arg0: str) -> None: ...
    @property
    def size(self) -> int: ...

class Model:
    def __init__(self) -> None: ...
    def add_attribute(self, arg0: str, arg1: Attribute) -> None: ...
    def attribute_exists(self, arg0: str) -> bool: ...
    def get_attribute(self, arg0: str) -> Attribute: ...
    def set_metadata(self, arg0: json) -> None: ...
    @property
    def geom_type(self) -> int: ...
    @property
    def metadata(self) -> json: ...

class Node:
    def __init__(self, arg0: int, arg1: float, arg2: float, arg3: json) -> None: ...

class Progress:
    def __init__(self, arg0: str) -> None: ...
    def update(self) -> None: ...
